<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <!-- Restructure questions. -->

  <xsl:template match="question">
    <xsl:copy>
      <xsl:if test="@selected">
        <xsl:element name="response">
          <xsl:apply-templates select="@selected"/>
          <xsl:for-each select="choice[position() = number(current()/@selected)]">
            <xsl:if test="not(response-type/@value = 'choice')">
              <xsl:apply-templates select="@response-text"/>
            </xsl:if>
          </xsl:for-each>
        </xsl:element>
      </xsl:if>
      <xsl:apply-templates select="choice"/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="choice">
    <xsl:if test="@selected = 'true' or response-type/@value='text'">
      <xsl:element name="response">
        <xsl:attribute name="selected"><xsl:value-of select="position()"/></xsl:attribute>
        <xsl:if test="not(response-type/@value = 'choice')">
          <xsl:apply-templates select="@response-text"/>
        </xsl:if>
      </xsl:element>
    </xsl:if>
  </xsl:template>



  <!-- Replicate unknown elements. -->

  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
